routes/web.php
<?php

use App\Http\Controllers\admin\CommonController;
use App\Http\Controllers\Admin\RoleController;
use App\Http\Controllers\admin\UsersController;
use App\Http\Controllers\admin\ProductsController;
use App\Http\Controllers\admin\OrderController;
use App\Http\Controllers\admin\PaymentsController;
use App\Http\Controllers\Auth\LoginController;
use Illuminate\Support\Facades\Route;
use App\Http\Controllers\SettingsController;
use App\Http\Controllers\HomeController;
use Illuminate\Support\Facades\Auth;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Auth::routes();
Route::get('/', [App\Http\Controllers\HomeController::class, 'index'])->name('home');
Route::get('/home', [App\Http\Controllers\HomeController::class, 'index'])->name('home');
Route::get('/orders', [App\Http\Controllers\HomeController::class, 'orders'])->name('orders');
Route::get('/payments', [App\Http\Controllers\HomeController::class, 'payments'])->name('payments');
Route::get('/items', [App\Http\Controllers\HomeController::class, 'items'])->name('items');
Route::get('/settings', [App\Http\Controllers\HomeController::class, 'settings'])->name('settings');
Route::get('/darkmode-switch/{mode}', [App\Http\Controllers\HomeController::class, 'darkmodeSwitch'])->name('darkmode-switch');
Route::post('user-login', [LoginController::class, 'userLogin'])->name('user-login');
Route::post('user-signup', [LoginController::class, 'userSignup'])->name('user-signup');

// Admin Routes
Route::get('/products', [App\Http\Controllers\HomeController::class, 'products'])->name('products');
Route::post('/create-product', [App\Http\Controllers\HomeController::class, 'createProduct'])->name('create-product');
Route::get('/all-orders', [App\Http\Controllers\HomeController::class, 'allOrders'])->name('all-orders');
Route::post('/create-order', [App\Http\Controllers\HomeController::class, 'createOrder'])->name('create-order');
Route::prefix('admin')->group(function () {
    Route::group(['middleware' => 'auth:web'], function () {
        Route::get('/settings', [HomeController::class, 'index']);
        Route::match(['get', 'post'], '/change-password', [SettingsController::class, 'change_password'])->name('change_password');
        Route::post('/update-settings', [SettingsController::class, 'update']);
        Route::resource('roles', RoleController::class);
        Route::resource('users', UsersController::class);
        Route::get('delete/{route}/{id}', [CommonController::class, 'delete'])->name('delete');
        // Route::resource('products', ProductsController::class);
        Route::post('get-product-value', [ProductsController::class, 'getProductValue'])->name('getProductValue');
        Route::resource('orders', OrderController::class);
        Route::resource('payments', PaymentsController::class);
        Route::post('get-append-rows', [OrderController::class, 'getAppendedRows'])->name('getAppendedRows');
        Route::get('getProducts', [ProductsController::class, 'getProducts'])->name('getProducts');
        Route::post('app-order', [OrderController::class, 'appOrder'])->name('app-order');
    });
});

app/Models/User.php
<?php

namespace App\Models;

use Illuminate\Contracts\Auth\MustVerifyEmail;
use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Foundation\Auth\User as Authenticatable;
use Illuminate\Notifications\Notifiable;
use Laravel\Sanctum\HasApiTokens;
use Spatie\Permission\Traits\HasRoles;

class User extends Authenticatable
{
    use HasApiTokens, HasFactory, Notifiable, HasRoles;

    /**
     * The attributes that are mass assignable.
     *
     * @var string[]
     */
    protected $fillable = [
        'name',
        'email',
        'phone',
        'type',
        'profile_photo',
        'password',
    ];

    /**
     * The attributes that should be hidden for serialization.
     *
     * @var array
     */
    protected $hidden = [
        'password',
        'remember_token',
    ];

    /**
     * The attributes that should be cast.
     *
     * @var array
     */
    protected $casts = [
        'email_verified_at' => 'datetime',
    ];
}

app/Http/Controllers/admin/UsersController.php
<?php

namespace App\Http\Controllers\admin;

use App\Http\Controllers\Controller;
use App\Models\User;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Artisan;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\File;
use Illuminate\Support\Facades\Hash;
use Illuminate\Support\Facades\Validator;
use Yajra\DataTables\Facades\DataTables;

class UsersController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index(Request $request)
    {
        Artisan::call('up');
        if ($request->ajax()) {
            $data = User::select('id', 'profile_photo', 'name', 'email', 'phone', 'status', 'type');
            return DataTables::of($data)
                ->addIndexColumn()
                ->addColumn('action', function ($row) {
                    $button = '<a href="' . url('admin/users') . '/' . $row->id . '/edit" class="btn btn-xs btn-outline-primary"><i class="fa fa-edit"></i></a>&nbsp';
                    if (Auth::id() != $row->id) {
                        $button .= '<button data-href="' . route('delete', ['users', $row->id]) . '" class="btn btn-xs btn-outline-danger btn-modal"><i class="fa fa-trash"></i></button>';
                    }
                    return $button;
                })
                ->addColumn('status', function ($row) {
                    if ($row->status == 1) {
                        return '<span class="badge badge-success">ACTIVE</span>';
                    } else {
                        return '<span class="badge badge-danger">IN ACTIVE</span>';
                    }
                })
                ->addColumn('profile_photo', function ($row) {
                    if ($row->profile_photo) {
                        return '<img src="' . asset($row->profile_photo) . '" style="height:50px" alt="' . $row->name . '">';
                    } else {
                        return '<img src="' . asset('img/user2.png') . '" style="height:50px" alt="' . $row->name . '">';
                    }
                })
                ->filter(function ($instance) use ($request) {
                    if (!empty($request->get('search'))) {
                        $instance->where(function ($w) use ($request) {
                            $search = $request->get('search');
                            $w->Where('name', 'LIKE', "%$search%");
                        });
                    }
                })
                ->rawColumns(['status', 'action', 'profile_photo'])
                ->make(true);
        }
        return view('admin.users.index');
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        return view('admin.users.create');
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        $rules = [
            'type'                              => 'required',
            'name'                              => 'required|string|min:3|max:30',
            'phone'                             => 'required|min:10|max:10|unique:users',
            'status'                            => 'required',
            'password'                          => 'required|confirmed|min:4',
            'password_confirmation'             => 'required',
        ];
        $messages = [
            'name.required'    => 'Name is required',
        ];
        $validation = Validator::make($request->all(), $rules, $messages);
        if ($validation->fails()) {
            return redirect()->back()->withErrors($validation)->withInput();
        }
        try {
            $user = new User();
            $user->type = $request->type;
            $user->name = $request->name;
            $user->phone = $request->phone;
            $user->status = $request->status;
            $user->password = Hash::make($request->password);
            $user->save();
            return redirect('admin/users')->with(['status' => 'success', 'message' => "USER ADDED SUCCESSFULLY"]);
        } catch (\Throwable $e) {
            return redirect()->back()->withErrors(['message' => $e->getMessage()])->withInput();
        }
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        $user = User::findOrFail($id);
        return view('admin.users.edit')->with(compact('user'));
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        $rules = [
            'type'                              => 'required',
            'name'                              => 'required|string|min:3|max:30',
            'phone'                             => 'required|min:10|max:10|unique:users,phone,' . $id,
            'status'                            => 'required',
        ];
        if ($request->password) {
            $rules = [
                'password'                      => 'required|confirmed|min:6',
                'password_confirmation'         => 'required',
            ];
        }
        $messages = [
            'name.required'    => 'Name is required',
        ];
        $validation = Validator::make($request->all(), $rules, $messages);
        if ($validation->fails()) {
            return redirect()->back()->withErrors($validation)->withInput();
        }
        try {
            $user_data = [
                'type'      => $request->type,
                'name'      => $request->name,
                'phone'     => $request->phone,
                'status'    => $request->status,
            ];
            User::where('id', $id)->update($user_data);
            return redirect()->back()->with(['status' => 'success', 'message' => 'USER UPDATED SUCCESSFULLY!']);
        } catch (\Exception $e) {
            return redirect()->back()->withErrors(['message' => $e->getMessage()])->withInput();
        }
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        if (Auth::id() == $id) {
            return response()->json(['success' => false, 'msg' => 'Active User cannot be deleted']);
        }
        if (request()->ajax()) {
            try {
                $user = User::findOrFail($id);
                $user->delete();
                return response()->json(['success' => true, 'msg' => 'successfully deleted']);
            } catch (\Exception $e) {
                return response()->json(['success' => false, 'msg' => $e->getMessage()]);
            }
        }
    }

    public function getUserRoleName($user_id)
    {
        $user = User::findOrFail($user_id);
        $roles = $user->getRoleNames();
        $role_name = '';
        if (!empty($roles[0])) {
            $role_name = !empty($roles[0]) ? $roles[0] : '';
        }
        return $role_name;
    }
}

resources/views/admin/users/create.blade.php
@include('admin.layouts.sidebar')
<!-- Content Wrapper. Contains page content -->
<div class="content-wrapper">
    <!-- Content Header (Page header) -->
    <section class="content-header">
      <div class="container-fluid">
        <div class="row mb-2">
          <div class="col-sm-6">
            {{-- @if (auth()->user()->can('roles')) --}}
                {{-- <a class="btn btn-primary" href="{{route('roles.create')}}"><i class="fa fa-plus"></i> ADD</a> --}}
            {{-- @endif --}}
          </div>
          <div class="col-sm-6">
            <ol class="breadcrumb float-sm-right">
                <li class="breadcrumb-item"><a href="{{url('admin')}}">HOME</a></li>
                <li class="breadcrumb-item"><a href="{{route('users.index')}}">USERS</a></li>
                <li class="breadcrumb-item active">CREATE</li>
            </ol>
          </div>
        </div>
      </div><!-- /.container-fluid -->
    </section>

    <!-- Main content -->
    <section class="content">
      <div class="container-fluid">
        @include('admin.layouts.error')
        <div class="row">
          <div class="col-12">
            <!-- general form elements -->
            <div class="card">
                <div class="card-header">
                    <h3 class="card-title">USERS</h3>
                </div>
                <div class="card-body">
                    <div id="example2_wrapper" class="dataTables_wrapper dt-bootstrap4">
                        <div class="row">
                            <div class="col-sm-12">
                                <form method="POST" action="{{route('users.store')}}" accept-charset="UTF-8" id="user_edit_form" enctype="multipart/form-data">
                                    @csrf 
                                    <div class="box-body">
                                    
                                        <div class="row">
                                            
                                            <div class="col-md-4">
                                                <div class="form-group">
                                                    <label for="name">TYPE:*</label>
                                                    <select class="form-control" name="type">
                                                        <option value="">SELECT USER TYPE</option>
                                                        <option value="admin" @if (old('type')=='admin') selected @endif>ADMIN</option>
                                                        <option value="user" @if (old('type')=='user') selected @endif>USER</option>
                                                        <option value="guest" @if (old('type')=='guest') selected @endif>GUEST</option>
                                                    </select>
                                                </div>
                                            </div>
                                            <div class="col-md-4">
                                                <div class="form-group">
                                                    <label for="name">NAME:*</label>
                                                    <input class="form-control" value="{{old('name')}}" required placeholder="User Name" name="name" type="text" id="name" autocomplete="off">
                                                </div>
                                            </div>
                                            <div class="col-md-4">
                                                <div class="form-group">
                                                    <label for="name">PHONE:*</label>
                                                    <input class="form-control" value="{{old('phone')}}" required placeholder="User Phone" name="phone" type="text" id="phone" autocomplete="off">
                                                </div>
                                            </div>
                                            <div class="col-md-4">
                                                <div class="form-group">
                                                    <label for="name">PIN:*</label>
                                                    <input class="form-control" type="password" name="password" id="password" placeholder="ENTER PASSWORD" required minlength="4">
                                                </div>
                                            </div>
                                            <div class="col-md-4">
                                                <div class="form-group">
                                                    <label for="name">CONFIRM PIN:*</label>
                                                    <input class="form-control" type="password" name="password_confirmation" placeholder="RE ENTER PASSWORD" required maxlength="4">
                                            </div>
                                            </div>
                                            <div class="col-md-4">
                                                <div class="form-group">
                                                    <label for="name">STATUS:*</label>
                                                    <select class="form-control" name="status">
                                                        <option value="1" @if (old('status')==1) selected @endif>ACTIVE</option>
                                                        <option value="2" @if (old('status')==2) selected @endif>INACTIVE</option>
                                                    </select>
                                                </div>
                                            </div>
                                        </div>
                                    
                                    </div>
                                    <!-- /.box-body -->
                                    <div class="box-footer">
                                        <button type="submit" class="btn btn-primary pull-right">SAVE</button>
                                    </div>
                                </form>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
          </div>
        </div>
      </div>
    </section>
</div>
@include('admin.layouts.footer')
<script >
    $("#userManagementNav").addClass('active');
    $("#usersNav").addClass('active');
</script>

resources/views/admin/users/edit.blade.php
@include('admin.layouts.sidebar')
<!-- Content Wrapper. Contains page content -->
<div class="content-wrapper">
    <!-- Content Header (Page header) -->
    <section class="content-header">
      <div class="container-fluid">
        <div class="row mb-2">
          <div class="col-sm-6">
            {{-- @if (auth()->user()->can('roles')) --}}
                {{-- <a class="btn btn-primary" href="{{route('roles.create')}}"><i class="fa fa-plus"></i> ADD</a> --}}
            {{-- @endif --}}
          </div>
          <div class="col-sm-6">
            <ol class="breadcrumb float-sm-right">
                <li class="breadcrumb-item"><a href="{{url('admin')}}">HOME</a></li>
                <li class="breadcrumb-item"><a href="{{route('users.index')}}">USERS</a></li>
                <li class="breadcrumb-item active">EDIT</li>
            </ol>
          </div>
        </div>
      </div><!-- /.container-fluid -->
    </section>

    <!-- Main content -->
    <section class="content">
      <div class="container-fluid">
        @include('admin.layouts.session')
        @include('admin.layouts.error')
        <div class="row">
          <div class="col-12">
            <!-- general form elements -->
            <div class="card">
                <div class="card-header">
                    <h3 class="card-title">USERS</h3>
                </div>
                <div class="card-body">
                    <div id="example2_wrapper" class="dataTables_wrapper dt-bootstrap4">
                        <div class="row">
                            <div class="col-sm-12">
                                <form method="POST" action="{{url('admin/users').'/'.$user->id}}" accept-charset="UTF-8" id="user_edit_form" enctype="multipart/form-data">
                                    <input name="_method" type="hidden" value="PUT">
                                    @csrf 
                                    <div class="box-body">
                                    
                                        <div class="row">
                                            <div class="col-md-6">
                                                <div class="form-group">
                                                    <label for="name">TYPE:*</label>
                                                    <select class="form-control" name="type">
                                                        <option value="">SELECT USER TYPE</option>
                                                        <option value="admin" @if (old('type',$user->type)=='admin') selected @endif>ADMIN</option>
                                                        <option value="user" @if (old('type',$user->type)=='user') selected @endif>USER</option>
                                                        <option value="guest" @if (old('type',$user->type)=='guest') selected @endif>GUEST</option>
                                                    </select>
                                                </div>
                                            </div>
                                            <div class="col-md-6">
                                                <div class="form-group">
                                                    <label for="name">NAME:*</label>
                                                    <input class="form-control" value="{{old('name',$user->name)}}" required placeholder="User Name" name="name" type="text" id="name" autocomplete="off">
                                                </div>
                                            </div>
                                            <div class="col-md-6">
                                                <div class="form-group">
                                                    <label for="name">PHONE:*</label>
                                                    <input class="form-control" value="{{old('phone',$user->phone)}}" required placeholder="User Phone" name="phone" type="text" id="phone" autocomplete="off">
                                                </div>
                                            </div>
                                            
                                            <div class="col-md-6">
                                                <div class="form-group">
                                                    <label for="name">STATUS:*</label>
                                                    <select class="form-control" name="status">
                                                        <option value="1" @if (old('status', $user->status) == '1') selected @endif>ACTIVE</option>
                                                        <option value="2" @if (old('status', $user->status) == '2') selected @endif>INACTIVE</option>
                                                    </select>
                                                </div>
                                            </div>
                                        </div>
                                    
                                    </div>
                                    <!-- /.box-body -->
                                    <div class="box-footer">
                                        <button type="submit" class="btn btn-primary pull-right">SAVE</button>
                                    </div>
                                </form>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
          </div>
        </div>
      </div>
    </section>
</div>
@include('admin.layouts.footer')
<script >
    $("#userManagementNav").addClass('active');
    $("#usersNav").addClass('active');
</script>

resources/views/admin/users/index.blade.php
@include('admin.layouts.sidebar')
<!-- Content Wrapper. Contains page content -->
<div class="content-wrapper">
    <!-- Content Header (Page header) -->
    <section class="content-header">
      <div class="container-fluid">
        <div class="row mb-2">
          <div class="col-sm-6">
            @if (auth()->user()->type=='admin')
                <a class="btn btn-primary" href="{{route('users.create')}}"><i class="fa fa-plus"></i> ADD</a>
            @endif
          </div>
          <div class="col-sm-6">
            <ol class="breadcrumb float-sm-right">
                <li class="breadcrumb-item"><a href="{{url('admin')}}">HOME</a></li>
                <li class="breadcrumb-item active">USERS</li>
            </ol>
          </div>
        </div>
      </div><!-- /.container-fluid -->
    </section>

    <!-- Main content -->
    <section class="content">
      <div class="container-fluid">
        <div class="row">
          <div class="col-12">
            <!-- general form elements -->
            @include('admin.layouts.session')
            <div class="card">
                <div class="card-header">
                    <h3 class="card-title">USERS</h3>
                </div>
                <div class="card-body">
                    <div id="example2_wrapper" class="dataTables_wrapper dt-bootstrap4">
                        <div class="row">
                            <div class="col-sm-12">
                                <table class="table table-bordered table-striped data-table">
                                    <thead>
                                        <tr>
                                            <th>NAME</th>
                                            <th>PHONE</th>
                                            <th>TYPE</th>
                                            <th>STATUS</th>
                                            <th>ACTION</th>
                                        </tr>
                                    </thead>
                                </table>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
          </div>
        </div>
      </div>
    </section>
</div>
<div class="modal fade modal_class" tabindex="-1" role="dialog" aria-labelledby="gridSystemModalLabel"></div>
@include('admin.layouts.footer')
<script >
    $(function () {
      var table = $('.data-table').DataTable({
        processing: true,
        serverSide: true,
        lengthMenu: [[25, 50, 100, 200, -1], [25, 50, 100, 200, "All"]],
        pageLength : 25,
        dom: "<'row'<'col-sm-2'l><'col-sm-7 text-center'B><'col-sm-3'f>><'row'<'col-sm-12'tr>><'row'<'col-sm-6'i><'col-sm-6'p>>",
        buttons: ["copy", "csv", "excel", "pdf", "print", "colvis"],
        ajax: {
          url: "{{ route('users.index') }}",
          data: function (d) {
                d.search = $('input[type="search"]').val();
            }
        },
        columns: [
            {data: 'name', name: 'name'},
            {data: 'phone', name: 'phone'},
            {data: 'type', name: 'type'},
            {data: 'status', name: 'status'},
            {data: 'action', name: 'action', orderable: false, searchable: false},
        ],
      });
    });
   </script>
   @include('admin.layouts.scripts')